//	Program:  ScreenRuler by BlatSoft
//	03/2016	version: 1.2.0
//  appbasic.js
//  This file used to setup standard App features such as menus/trays, system info, etc
//  - Called from end of index.html file

"use strict";

// **********************  js lint suppressions  **************************
/*jslint node: true */
/*jslint browser: true*/
/*global $, jQuery, alert*/
//require('nw.gui').Window.get().showDevTools();
// **********************  Init Variables  ************************
var freePercent, osCheck, numCPUs, typeCPUs, platCheck, browCheck, ua, browser, osnCheck, backData, nw, win, nativeMenuBar, fs, fileName, tray, trayMenu, filePath;

// **********************  npm modules  **************************
// load native UI
//var nw = require('nw.gui');
// load filesystem API
//var fse = require('fs-extra');
// load OS system API
//var os = require('os');
// load OS Name API
//var osName = require('os-name');

var platform = require('platform');
//var paths = require('process');
// use to replace ALERT which crashes App
//var mess = require('dialog');

win = nw.Window.get();


function appMenus() {
    // **********************  Build Menus  **************************
    console.log("platform.os.family" + platform.os.family);
    console.log("Platform - " + platform);
    if (platform.os.family === "Darwin") {
        // use Native OSX menu system
        // create empty menu

        nativeMenuBar = new nw.Menu({
            type: "menubar"
        });
        nativeMenuBar.createMacBuiltin("TestProject", {
            hideEdit: true
        });

        //var filePath2;
        //b filePath2 = paths.env.HOME + '/Desktop/BWS/Resources/';
        //filePath2 = paths.env.HOME + '/Desktop/DevApps/ScreenRuler/Resources/';
        //console.log("filePath2 - " + filePath2);
        nativeMenuBar.append(new nw.MenuItem({
            label: 'Help',
            submenu: new nw.Menu()
        })); // insert File as first user Menu (App-name is always 0)

        nativeMenuBar.items[0].submenu.insert(new nw.MenuItem({
            type: 'separator'
        }), 1);


        win.menu = nativeMenuBar;

    }

    if (platform.os.family === "Darwin") {
        // Use Context Menu system

        // Create a tray icon  // only needed for actual OSX Tray on Menubar
        //    var tray = new nw.Tray({
        //        icon: 'sricon.png',
        //        title: 'ScreenRuler'
        //    });

        // Give it a menu - default is ContextMenu
        var menu = new nw.Menu();
        menu.append(new nw.MenuItem({
            type: 'separator'
        }));
        menu.append(new nw.MenuItem({
            label: 'Close App',
            type: 'normal',
            click: function () {
                win.close(true);
            }
        }));

        //tray.menu = menu;

        document.body.addEventListener('contextmenu', function (e) {
            e.preventDefault();
            menu.popup(e.x, e.y);
            return false;
        }, false);

    }




    //} else {
    if (platform.os.family === "Win32") {
        // may need to adjust for 0.13.0
        // Create a tray icon
        var tray = new nw.Tray({
            icon: 'sricon.png',
            title: 'ScreenRuler'
        });

        // Give it a menu
        var menu = new nw.Menu();
        menu.append(new nw.MenuItem({
            type: 'normal',
            label: 'About ScreenRuler',
            click: function () {
                var credwin = nw.Window.open('Resources/wCredits.html', {
                    width: 400,
                    height: 320,
                    fullscreen: false,
                    top: true,
                    resizable: false,
                    toolbar: false
                });
                credwin.on('loaded', function () {
                    credwin.focus();
                    credwin.setAlwaysOnTop(true);
                });

                // Release the 'win' object here after the new window is closed.
                credwin.on('closed', function () {
                    credwin = null;
                });

                // Listen to main window's close event
                nw.Window.get().on('close', function () {
                    // May want to hide the window to give user the feeling of closing immediately
                    // this.hide();

                    // If the new window is still open then close it.
                    if (credwin != null) {
                        credwin.close(true);
                        // After closing the new window, close the main window.
                        this.close(true);
                    }
                    this.close(true); // required otherwise main win will not close after prefs closed.
                });
            }
        }));

        tray.menu = menu;
    }

} // end appmenus()
//  *********************** Platform dependent Window Controls  *****************************

function setWinControls() { // called from end of index.html

    if (platform.os.family === "Darwin") {
        document.getElementById('ulwin').style.display = "none";

        document.getElementById('winControlMinOSX').onclick = function () {
                win.minimize();
            }
            // Maximize disabled for fixed size widgets
            //document.getElementById('winControlMaxOSX').onclick = function () {
            //    if (win.isMaximized) {
            //        win.unmaximize();
            //        win.isMaximized = false;
            //    } else {
            //        win.maximize();
            //    }
            //}
        document.getElementById('winControlCloseOSX').onclick = function () {
            win.close();
        }

        win.on('maximize', function () {
            win.isMaximized = true;
        });

        win.on('unmaximize', function () {
            win.isMaximized = false;
        });


    }
    if (platform.os.family === "Win32") {
        document.getElementById("ulosx").style.display = "none";

        document.getElementById('winControlMinW32').onclick = function () {
                //                win.minimize();
                if (win.isMinimized) {
                    win.unminimize();
                    win.isMinimized = false;
                } else {
                    win.minimize();
                }
            }
            // Maximize disabled for fixed size widgets
            //document.getElementById('winControlMaxW32').onclick = function () {
            //    if (win.isMaximized) {
            //        win.unmaximize();
            //        win.isMaximized = false;
            //    } else {
            //        win.maximize();
            //    }
            //}
        document.getElementById('winControlCloseW32').onclick = function () {
            win.close();
        }

        win.on('maximize', function () {
            win.isMaximized = true;
        });

        win.on('unmaximize', function () {
            win.isMaximized = false;
        });
    }
}

appMenus();
setWinControls();